=== debian/changelog ===
skopeo (1.16.1+ds1-1) unstable; urgency=medium

  * New upstream version

 -- Reinhard Tartler <siretart@tauware.de>  Thu, 12 Sep 2024 18:10:11 -0400
