=== debian/changelog ===
skopeo (1.17.0+ds1-1) unstable; urgency=medium

  * New upstream version
  * system-tests: add ca-certificates

 -- Reinhard Tartler <siretart@tauware.de>  Thu, 21 Nov 2024 18:18:07 -0500
