## skopeo 1.18.0+ds1

=== debian/changelog ===
skopeo (1.18.0+ds1-1) unstable; urgency=medium

  * New upstream version

 -- Reinhard Tartler <siretart@tauware.de>  Mon, 07 Apr 2025 06:54:35 -0400
