=== debian/changelog ===
skopeo (1.20.0+ds1-2) unstable; urgency=medium

  * Require golang-github-spf13-cobra-dev (>> 1.10.1)
  * Bump Standards Version, no changes needed
  * debian/copyright: Clarify that license as Apache 2.0
  * Use modern way to declare debhelper compat level
  * Switch to Static-Build-Using field

 -- Reinhard Tartler <siretart@tauware.de>  Mon, 29 Sep 2025 05:41:00 -0400

skopeo (1.20.0+ds1-1) unstable; urgency=medium

  * New upstream release 1.20.0
    - Breaking Change: The `unshare` command now requires the `CAP_SYS_ADMIN`
      capability.
    - Security: GPG key handling updated to disallow weak SHA-1 signatures.
    - Feature: Add initial support for Sequoia-based signing via
      `--sign-by-sq-fingerprint`.
    - Build: Now links dynamically against the system `sqlite3` library.
    - Fix: Correctly recognize "tag not found" errors for `oci:` and
      `oci-archive:` transports.

  * New upstream release 1.19.0
    - Breaking Change: `skopeo inspect` and `skopeo layers` now enforce
      manifest and blob digest validation for improved integrity.
    - Feature: Add shell completions for image transport names.

 -- Reinhard Tartler <siretart@tauware.de>  Sun, 28 Sep 2025 18:23:08 -0400
