=== debian/control ===
--- 
+++ 
@@ -4,6 +4,7 @@
 Maintainer: Debian Go Packaging Team <team+pkg-go@tracker.debian.org>
 Uploaders: Reinhard Tartler <siretart@tauware.de>
 Build-Depends: debhelper (>= 11~),
+               debhelper-compat (= 13),
                dh-golang,
                go-md2man,
                golang-any,
@@ -16,7 +17,7 @@
                golang-github-pkg-errors-dev,
                golang-github-sigstore-sigstore-dev,
                golang-github-sirupsen-logrus-dev,
-               golang-github-spf13-cobra-dev (>> 1.2.1),
+               golang-github-spf13-cobra-dev (>> 1.10.1),
                golang-github-stretchr-testify-dev,
                golang-github-urfave-cli-dev,
                golang-gopkg-check.v1-dev,
@@ -24,7 +25,7 @@
 # tests:
 #              golang-github-opencontainers-image-tools-image-dev,
 Build-Conflicts: golang-github-dnephin-cobra-dev
-Standards-Version: 4.6.0
+Standards-Version: 4.7.2
 Homepage: https://github.com/containers/skopeo
 Vcs-Browser: https://salsa.debian.org/go-team/packages/skopeo
 Vcs-Git: https://salsa.debian.org/go-team/packages/skopeo.git
@@ -33,7 +34,7 @@
 
 Package: skopeo
 Architecture: any
-Built-Using: ${misc:Built-Using}
+Static-Built-Using: ${misc:Static-Built-Using}
 Depends: golang-github-containers-common (>> 0.49),
          ${misc:Depends},
          ${shlibs:Depends}
