=== debian/rules ===
#!/usr/bin/make -f

# exclude the integration tests for now
#
# Without this exclude, the build fails with:
# # github.com/containers/skopeo/integration
# runtime.main_main·f: function main is undeclared in the main package
export DH_GOLANG_EXCLUDES := skopeo/integration

export DH_GOLANG_GO_GENERATE := 1
export DH_GOLANG_INSTALL_EXTRA := $(shell find . -type f -name '*.json' -or -name '*.signature' -or -name '*.gpg')


override_dh_auto_install:
	dh_auto_install -- --no-source

override_dh_installman:
	make docs
	dh_installman -pskopeo docs/*.1

%:
	dh $@ --buildsystem=golang --with=golang
