=== debian/tests/control ===
Test-Command: skopeo help

Test-Command: env PODMAN_IGNORE_CGROUPSV1_WARNING=1 SKOPEO_BINARY=/usr/bin/skopeo HOME=/tmp bats --no-tempdir-cleanup --print-output-on-failure systemtest/
Depends: apache2-utils,
         bats,
         ca-certificates,
         fuse-overlayfs,
         golang-any,
         gpg,
         gpg-agent,
         jq,
         openssl,
         podman,
         @
Restrictions: allow-stderr, needs-root, isolation-machine
