=== debian/watch ===
# uscan(1) configuration file.
version=4

opts="\
pgpmode=none,\
repacksuffix=+ds1,\
repack,compression=xz,\
dversionmangle=auto,\
filenamemangle=s%(?:.*?)?v?@ANY_VERSION@(@ARCHIVE_EXT@)%@PACKAGE@-$1$2%" \
  https://github.com/containers/skopeo/tags \
  (?:.*?/)?v?@ANY_VERSION@@ARCHIVE_EXT@
