=== debian/changelog ===
skopeo (1.21.0~pre1-2) unstable; urgency=medium

  * Upload to unstable

 -- Reinhard Tartler <siretart@tauware.de>  Thu, 27 Nov 2025 11:17:00 -0500

skopeo (1.21.0~pre1-1) experimental; urgency=medium

  * New upstream pre-release version
  * debian/control: tighten dependencies on containers/{storage,image,common}

 -- Reinhard Tartler <siretart@tauware.de>  Wed, 26 Nov 2025 05:39:51 -0500
