=== debian/control ===
--- 
+++ 
@@ -8,9 +8,9 @@
                dh-golang,
                go-md2man,
                golang-any,
-               golang-github-containers-common-dev (>> 0.49.1),
-               golang-github-containers-image-dev (>> 5.28.0-3~),
-               golang-github-containers-storage-dev (>> 1.42),
+               golang-github-containers-common-dev (>> 0.66),
+               golang-github-containers-image-dev (>> 5.38),
+               golang-github-containers-storage-dev (>> 1.61),
                golang-github-docker-docker-dev (>> 20.10),
                golang-github-opencontainers-go-digest-dev,
                golang-github-opencontainers-image-spec-dev,
