=== debian/rules ===
--- 
+++ 
@@ -8,8 +8,11 @@
 export DH_GOLANG_EXCLUDES := skopeo/integration
 
 export DH_GOLANG_GO_GENERATE := 1
-export DH_GOLANG_INSTALL_EXTRA := $(shell find . -type f -name '*.json' -or -name '*.signature' -or -name '*.gpg')
-
+export DH_GOLANG_INSTALL_EXTRA := \
+	$(wildcard *.json) \
+	$(wildcard cmd/skopeo/fixtures/*) \
+	$(wildcard integration/fixtures/*) 	$(wildcard integration/fixtures/*/*) \
+	$(EOL)
 
 override_dh_auto_install:
 	dh_auto_install -- --no-source
