=== debian/watch ===
Version: 5

Template: Github
Owner: containers
Project: skopeo
Dversion-Mangle: auto
Repack-Suffix: +ds1
